/*
 * ReadDirectory.h
 *
 *  Created on: 28.04.2011
 *      Author: nick
 */

#ifndef READDIRECTORY_H_
#define READDIRECTORY_H_

#define FUSE_USE_VERSION 26
#include <fuse.h>
#include <fcntl.h>
#include <list>
#include <map>
#include "../XML/Protocol.h"
#include "../XML_TagTypes/ReadDir.h"
#include "../XML_TagTypes/GetAttr.h"
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <string.h>

static int hello_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
                         off_t offset, struct fuse_file_info *fi);

class ReadDirectory/*:TagHandler<TagIQ>*/ {
	//class
	Protocol* protocol;
	fuse_operations* clientFsoperations;
	map<string,pair <int,TagIQ> > req_id;
private:
	ReadDirectory(Protocol &protocol, fuse_operations& clientFsoperations);
public:
	Protocol* getProtocol(){return protocol;}
	/// virtual void handleTag(TagIQ &tag);
	static ReadDirectory* getInstance(Protocol* protocol=NULL, fuse_operations* clientFsoperations=NULL);
	/*TagIQ void*/
	///ReadDir
	/*void*/
//	getFiles(string dir);
	virtual ~ReadDirectory();
	//friend static int hello_readdir(const char *path, void *buf, fuse_fill_dir_t filler, off_t offset, struct fuse_file_info *fi);
};
#endif /* READDIRECTORY_H_ */
