#ifndef BINARYPROTOCOL_H_
#define BINARYPROTOCOL_H_
using namespace std;
struct BibaryPacket;

//typedef void (BibaryPacket::*packetRecerver);
struct BibaryPacket;

#pragma pack(push,1)
struct BibaryPacketHeader{
	unsigned short pktID;
	unsigned short headSize;
	unsigned int bodySize;
};
#pragma pack(pop)

struct BibaryPacket{
	BibaryPacketHeader header;
	void * body;
};

template <class Listener_T> class BinaryProtocol{
public:
    typedef void (Listener_T::*packetRecerver)(BibaryPacket);
	BinaryProtocol(){};
	void connect(unsigned int ip, unsigned short port){};
	void disconnect(){};
	void setRecervedPacketFunc(packetRecerver func,unsigned short pktID){};
	void sendPacket(int size, void *data){};	
	virtual ~BinaryProtocol(){};
};

#endif /*BINARYPROTOCOL_H_*/
