#include "BaseConfigFile.h"

/*BaseConfigFile::BaseConfigFile()
{
}*/

BaseConfigFile::BaseConfigFile(char* filename){
	xfStart();
	conf=xfCreate();
	int r = xfReadFile(conf,filename);
	if (r) {
	  if (r == XFE_IO) printf("xflib_conf: cannot open file '%s'\n",filename);
	  if (r == XFE_MEMORY) printf("xflib_conf: not enough memory\n");
	  if (r == XFE_FORMAT) {
	    printf("xflib_conf: error parsing file '%s': %S (line %i col %i)\n",
	    		filename,xfGetError(conf),xfGetErrorLine(conf),xfGetErrorCol(conf));
	  }
	  xfDestroy(conf);
	  exit(1);
	}
	root=xfEnter(conf->root,L"conf");
}

BaseConfigFile::~BaseConfigFile()
{
}
