#ifndef SERVERCONFIG_H_
#define SERVERCONFIG_H_

#include "BaseConfigFile.h"
#include <list>
#include <string>
#include <sstream>

class ServerConfig : public BaseConfigFile
{
protected:
	xfNode* server_node;
	//xfChar*
	string shareddir;
public:
	//char*
	string getSharedDir(){return shareddir;};//директория в которой хранятся файлы доступные через данный сервер ФС
	unsigned int getServerPort(){return 0;};//получение порта через который сервер будет одидать подключения
	list<int> *getServerIps(){return NULL;};//Список IP адресов через которые сервер будет ожидать подключения клиентов	
	ServerConfig();
	virtual ~ServerConfig();
	//static ServerConfig* getInstance();
};
//static ServerConfig confFile;

#endif /*SERVERCONFIG_H_*/
