/*
 * Client.cpp
 *
 *  Created on: 09.04.2011
 *      Author: nick
 */

#include "Client.h"

//template <class Listener_T>
void Client/*<Listener_T>*/::connect_server(char* address, u_int16_t port){
    struct sockaddr_in stSockAddr;
    int i32Res;
    skt_id = socket( PF_INET, SOCK_STREAM, IPPROTO_TCP );
    if ( skt_id == -1 ){
        cout<< "Ошибка: невозможно создать сокет"<<endl;
        exit( EXIT_FAILURE );
    }

    memset( &stSockAddr, 0, sizeof( stSockAddr ) );

    stSockAddr.sin_family = PF_INET;
    stSockAddr.sin_port = htons(port);
    i32Res = inet_pton( PF_INET, address, &stSockAddr.sin_addr );

    if ( i32Res < 0 ){
        cout<< "Ошибка: первый параметр не относится к категории корректных адресов"<<endl;
        close( skt_id );
        exit( EXIT_FAILURE );
    }else
      if ( !i32Res ){
    	  cout<< ( "Ошибка: второй параметр не содержит корректного IP-адреса" );
          close( skt_id );
          exit( EXIT_FAILURE );
      }

    if (connect(skt_id,( const sockaddr* )&stSockAddr, sizeof( stSockAddr )) == -1){
        cout<<"Ошибка соединения"<<endl;
        close( skt_id );
        exit( EXIT_FAILURE );
    }
    parserCreate(skt_id);
    curNodeSend=new Node("stream:stream",NULL);
    pthread_create(&clientThread,NULL,client_threadFunc,this);
    //Создаем и отправляем начальную ноду
    //createNodeSend();
    /* выполнение операций чтения и записи ... */
    //shutdown( i32SocketFD, SHUT_RDWR );
    //close( i32SocketFD );
}

void Client::createNodeSend(){
	cout<< "====================== START STREAM ===================="<<endl;
	sendNodeStart(*curNodeSend);
}
void* client_threadFunc(void* clnt){
	Client* cl= static_cast<Client*> (clnt);
    cl->createNodeSend();
	cl->startParsing(/*cl->skt_id*/);
	return NULL;
}

void Client::startXMLTagNodeHandler(Node* node){
	cout<<"START NODE, RUN THREAD!"<<endl;
    //pthread_create(&clientThread,NULL,client_threadFunc,this);
}

void Client::endXMLTagNodeHandler(Node* node){
	cout<< "======================= END STREAM ====================="<<endl;
	sendNodeEnd(*curNodeSend);
	delete curNodeSend;
	curNodeSend=NULL;
}
//template <class Listener_T>
Client/*<Listener_T>*/::Client() {
	// TODO Auto-generated constructor stub

}

//template <class Listener_T>
Client/*<Listener_T>*/::~Client() {
	// TODO Auto-generated destructor stub
}
