/*
 * Stanza.h
 *
 *  Created on: 19.04.2011
 *      Author: nick
 */

#ifndef STANZA_H_
#define STANZA_H_
#include "Node.h"
#include <sstream>
using namespace std;

#define FROM "from"
#define TO "to"
#define ID "id"
static int curid=0;
class Stanza: public Node {
public:
	virtual ~Stanza();
	Stanza(string name, map <string, string> &attrs,  Node* parent);
	Stanza(string name,  Node* parent,string from="", string to="", string id="");
	void setID(string id){setAttribute("id",id);}
	void setFrom(string from){return setAttribute(FROM,from);};
	void setTo(string to){return setAttribute(TO,to);};
	string getFrom(){return getAttribute(FROM);};
	string getID(){return getAttribute(ID);}
	string getTo(){return getAttribute(TO);};
	static string generateID(){
		stringstream res;
		curid++;
		res<<"id_"<<curid;
		return res.str();
	}
	Stanza(const Node &basedNode);
};

#endif /* STANZA_H_ */
