/*
 * TagIQ.h
 *
 *  Created on: 18.04.2011
 *      Author: nick
 */

#ifndef TAGIQ_H_
#define TAGIQ_H_
#include "Node.h"
#include "Stanza.h"
#define QUERY_TAG "query"

class TagIQ:public Stanza {
public:
	enum IQType{
		Set=0,
		Get,
		Result,
		Error,
		Invalid
	};
protected:
	IQType subtype;
	Node* subNode;
	void setIQTypeF();
	virtual void copyKinds(const Node &basedNode);
public:
	IQType getType(){return subtype;}
	void setType(IQType type);
	virtual void addChild(Node* child);
	//Node* parent=NULL,string from="", string to="", IQType type=Get, string id="",string queryXMLNS=""
	TagIQ(Node* parent=NULL,string from="", string to="", IQType type=Get, string id="",string queryXMLNS="");
	TagIQ(const Node &basedNode);
	Node* getSubNode(){return subNode;}
	virtual ~TagIQ();
};

#endif /* TAGIQ_H_ */
