/*
 * GetAttr.h
 *
 *  Created on: 22.05.2011
 *      Author: nick
 */

#ifndef GETATTR_H_
#define GETATTR_H_
#include <iostream>
#include "../XML/TagIQ.h"
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#define GetAttr_subNodeName "getattr-data"
#define GetAttr_xmlnsData "getattr-data"
#define GetAttr_xmlnsDataPath "getattr-data#path"
#define GetAttr_xmlnsDataMode "getattr-data#mode"
#define GetAttr_xmlnsDataNlink "getattr-data#nlink"
using namespace std;

class GetAttr: public TagIQ {
public:
	GetAttr(Node* parent=NULL,string from="", string to="", IQType type=TagIQ::Get, string id="");
	GetAttr(const Node &basedNode);
	string getPath();
	void setPath(string path);
	struct stat getFileInfo();
	void setFileInfo(__mode_t mode, __nlink_t nlinks);
	virtual ~GetAttr();
};

#endif /* GETATTR_H_ */
